Index: /trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 17637)
+++ /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 17638)
@@ -137,5 +137,5 @@
 	vboxdrv \
 	$(if $(VBOX_WITH_NETFLT),vboxflt,) \
-	$(if $(VBOX_WITH_USB),vboxusb,) \
+	$(if $(VBOX_WITH_USB),vboxusbmon,) \
 	VBoxDD.so \
 	VBoxDD2.so \
@@ -204,5 +204,5 @@
 	vboxdrv.conf \
 	$(if $(VBOX_WITH_NETFLT),vboxflt.conf,) \
-	$(if $(VBOX_WITH_USB),vboxusb.conf,) \
+	$(if $(VBOX_WITH_USB),vboxusbmon.conf,) \
 	vboxdrv.sh \
 	VBox.sh \
@@ -382,5 +382,5 @@
 		$(PATH_ROOT)/src/VBox/HostDrivers/Support/solaris/vboxdrv.conf \
 		$(if $(VBOX_WITH_NETFLT),$(PATH_ROOT)/src/VBox/HostDrivers/VBoxNetFlt/solaris/vboxflt.conf,) \
-		$(if $(VBOX_WITH_USB),$(PATH_ROOT)/src/VBox/HostDrivers/VBoxUSB/solaris/vboxusb.conf,) \
+		$(if $(VBOX_WITH_USB),$(PATH_ROOT)/src/VBox/HostDrivers/VBoxUSB/solaris/vboxusbmon.conf,) \
 		$(if $(not $(VBOX_WITH_NETFLT))$(PATH_ROOT)/src/VBox/Devices/Network/solaris/vnicinit_solaris.sh,) \
 		$(if $(not $(VBOX_WITH_NETFLT))$(PATH_ROOT)/src/VBox/Devices/Network/solaris/vnicterm_solaris.sh,) \
@@ -404,5 +404,5 @@
 	$(QUIET)$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/Support/solaris/vboxdrv.conf               $(SOLARIS_INST_DIR)/vboxdrv.conf
 	$(QUIET)$(if $(VBOX_WITH_NETFLT),$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/VBoxNetFlt/solaris/vboxflt.conf         $(SOLARIS_INST_DIR)/vboxflt.conf,)
-	$(QUIET)$(if $(VBOX_WITH_USB),$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/VBoxUSB/solaris/vboxusb.conf               $(SOLARIS_INST_DIR)/vboxusb.conf,)
+	$(QUIET)$(if $(VBOX_WITH_USB),$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/VBoxUSB/solaris/vboxusbmon.conf               $(SOLARIS_INST_DIR)/vboxusbmon.conf,)
 	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(PATH_BIN)/LICENSE                                        $(SOLARIS_INST_DIR)/LICENSE)
 	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(PATH_BIN)/LICENSE                                        $(SOLARIS_INST_DIR)/vbox.copyright)
Index: /trunk/src/VBox/Installer/solaris/makepackage.sh
===================================================================
--- /trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 17637)
+++ /trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 17638)
@@ -138,12 +138,12 @@
 filelist_fixup prototype '$3 == "opt/VirtualBox/amd64/vboxflt=amd64/vboxflt"'                           '$3 = "platform/i86pc/kernel/drv/amd64/vboxflt=amd64/vboxflt"; $6 = "sys"'
 
-# USB vboxusb
-filelist_fixup prototype '$3 == "opt/VirtualBox/i386/vboxusb=i386/vboxusb"'                             '$3 = "platform/i86pc/kernel/drv/vboxusb=i386/vboxusb"; $6 = "sys"'
-filelist_fixup prototype '$3 == "opt/VirtualBox/amd64/vboxusb=amd64/vboxusb"'                           '$3 = "platform/i86pc/kernel/drv/amd64/vboxusb=amd64/vboxusb"; $6 = "sys"'
+# USB vboxusbmon
+filelist_fixup prototype '$3 == "opt/VirtualBox/i386/vboxusbmon=i386/vboxusbmon"'                       '$3 = "platform/i86pc/kernel/drv/vboxusbmon=i386/vboxusbmon"; $6 = "sys"'
+filelist_fixup prototype '$3 == "opt/VirtualBox/amd64/vboxusbmon=amd64/vboxusbmon"'                     '$3 = "platform/i86pc/kernel/drv/amd64/vboxusbmon=amd64/vboxusbmon"; $6 = "sys"'
 
 # All the driver conf files
 filelist_fixup prototype '$3 == "opt/VirtualBox/vboxdrv.conf=vboxdrv.conf"'                             '$3 = "platform/i86pc/kernel/drv/vboxdrv.conf=vboxdrv.conf"'
 filelist_fixup prototype '$3 == "opt/VirtualBox/vboxflt.conf=vboxflt.conf"'                             '$3 = "platform/i86pc/kernel/drv/vboxflt.conf=vboxflt.conf"'
-filelist_fixup prototype '$3 == "opt/VirtualBox/vboxusb.conf=vboxusb.conf"'                             '$3 = "platform/i86pc/kernel/drv/vboxusb.conf=vboxusb.conf"'
+filelist_fixup prototype '$3 == "opt/VirtualBox/vboxusbmon.conf=vboxusbmon.conf"'                       '$3 = "platform/i86pc/kernel/drv/vboxusbmon.conf=vboxusbmon.conf"'
 
 # hardening requires some executables to be marked setuid.
Index: /trunk/src/VBox/Installer/solaris/postinstall.sh
===================================================================
--- /trunk/src/VBox/Installer/solaris/postinstall.sh	(revision 17637)
+++ /trunk/src/VBox/Installer/solaris/postinstall.sh	(revision 17638)
@@ -43,12 +43,12 @@
             fi
 
-            if test -f /platform/i86pc/kernel/drv/vboxusb.conf && test "$osversion" != "5.10"; then
+            if test -f /platform/i86pc/kernel/drv/vboxusbmon.conf && test "$osversion" != "5.10"; then
                 /opt/VirtualBox/vboxdrv.sh usbstart
                 rc=$?
                 if test "$rc" -eq 0; then
-                    # add vboxusb to the devlink.tab
+                    # add vboxusbmon to the devlink.tab
                     sed -e '
-                    /name=vboxusb/d' /etc/devlink.tab > /etc/devlink.vbox
-                    echo "type=ddi_pseudo;name=vboxusb	\D" >> /etc/devlink.vbox
+                    /name=vboxusbmon/d' /etc/devlink.tab > /etc/devlink.vbox
+                    echo "type=ddi_pseudo;name=vboxusbmon	\D" >> /etc/devlink.vbox
                     mv -f /etc/devlink.vbox /etc/devlink.tab
                 fi
@@ -112,6 +112,6 @@
 
     # don't create link for Solaris 10
-    if test -f /platform/i86pc/kernel/drv/vboxusb.conf && test "$osversion" != "5.10"; then
-        /usr/sbin/devfsadm -i vboxusb
+    if test -f /platform/i86pc/kernel/drv/vboxusbmon.conf && test "$osversion" != "5.10"; then
+        /usr/sbin/devfsadm -i vboxusbmon
     fi
     sync
Index: /trunk/src/VBox/Installer/solaris/preremove.sh
===================================================================
--- /trunk/src/VBox/Installer/solaris/preremove.sh	(revision 17637)
+++ /trunk/src/VBox/Installer/solaris/preremove.sh	(revision 17638)
@@ -47,7 +47,7 @@
     mv -f /etc/devlink.vbox /etc/devlink.tab
 
-    # remove devlink.tab entry for vboxusb
+    # remove devlink.tab entry for vboxusbmon
     sed -e '
-/name=vboxusb/d' /etc/devlink.tab > /etc/devlink.vbox
+/name=vboxusbmon/d' /etc/devlink.tab > /etc/devlink.vbox
     mv -f /etc/devlink.vbox /etc/devlink.tab
 
@@ -56,6 +56,6 @@
         rm -f /dev/vboxdrv
     fi
-    if test -h "/dev/vboxusb" || test -f "/dev/vboxusb"; then
-        rm -f /dev/vboxusb
+    if test -h "/dev/vboxusbmon" || test -f "/dev/vboxusbmon"; then
+        rm -f /dev/vboxusbmon
     fi
 fi
Index: /trunk/src/VBox/Installer/solaris/vboxdrv.sh
===================================================================
--- /trunk/src/VBox/Installer/solaris/vboxdrv.sh	(revision 17637)
+++ /trunk/src/VBox/Installer/solaris/vboxdrv.sh	(revision 17638)
@@ -25,5 +25,5 @@
 VBIMODNAME="vbi"
 FLTMODNAME="vboxflt"
-USBMODNAME="vboxusb"
+USBMODNAME="vboxusbmon"
 MODDIR32="/platform/i86pc/kernel/drv"
 MODDIR64=$MODDIR32/amd64
@@ -123,5 +123,5 @@
 }
 
-vboxusb_added()
+vboxusbmon_added()
 {
     module_added $USBMODNAME
@@ -129,5 +129,5 @@
 }
 
-vboxusb_loaded()
+vboxusbmon_loaded()
 {
     module_loaded $USBMODNAME
@@ -253,12 +253,12 @@
 
 
-start_vboxusb()
-{
-    if vboxusb_loaded; then
-        info "VirtualBox USB kernel module already loaded."
-    else
-        /usr/sbin/add_drv -m'* 0600 root sys' $USBMODNAME || abort "Failed to add VirtualBox USB Kernel module."
+start_vboxusbmon()
+{
+    if vboxusbmon_loaded; then
+        info "VirtualBox USB Monitor kernel module already loaded."
+    else
+        /usr/sbin/add_drv -m'* 0600 root sys' $USBMODNAME || abort "Failed to add VirtualBox USB Monitor Kernel module."
         /usr/sbin/modload -p drv/$USBMODNAME
-        if test ! vboxusb_loaded; then
+        if test ! vboxusbmon_loaded; then
             abort "Failed to load VirtualBox USB kernel module."
         else
@@ -268,10 +268,10 @@
 }
 
-stop_vboxusb()
-{
-    if vboxusb_loaded; then
-        vboxusb_mod_id=`/usr/sbin/modinfo | grep $USBMODNAME | cut -f 1 -d ' '`
-        if test -n "$vboxusb_mod_id"; then
-            /usr/sbin/modunload -i $vboxusb_mod_id
+stop_vboxusbmon()
+{
+    if vboxusbmon_loaded; then
+        vboxusbmon_mod_id=`/usr/sbin/modinfo | grep $USBMODNAME | cut -f 1 -d ' '`
+        if test -n "$vboxusbmon_mod_id"; then
+            /usr/sbin/modunload -i $vboxusbmon_mod_id
 
             # see stop_vboxdrv() for why we have "alwaysremdrv".
@@ -280,7 +280,7 @@
             else
                 if test "$?" -eq 0; then
-                    /usr/sbin/rem_drv $USBMODNAME || abort "Unloaded VirtualBox USB kernel module, but failed to remove it!"
+                    /usr/sbin/rem_drv $USBMODNAME || abort "Unloaded VirtualBox USB Monitor kernel module, but failed to remove it!"
                 else
-                    abort "Failed to unload VirtualBox USB kernel module. Old one still active!!"
+                    abort "Failed to unload VirtualBox USB Monitor kernel module. Old one still active!!"
                 fi
             fi
@@ -288,6 +288,6 @@
             info "VirtualBox USB kernel module unloaded."
         fi
-    elif vboxusb_added; then
-        /usr/sbin/rem_drv $USBMODNAME || abort "Unloaded VirtualBox USB kernel module, but failed to remove it!"
+    elif vboxusbmon_added; then
+        /usr/sbin/rem_drv $USBMODNAME || abort "Unloaded VirtualBox USB Monitor kernel module, but failed to remove it!"
         info "VirtualBox USB kernel module unloaded."
     elif test -z "$SILENTUNLOAD"; then
@@ -309,5 +309,5 @@
 stop_all_modules()
 {
-    stop_vboxusb
+    stop_vboxusbmon
     stop_vboxflt
     stop_module
@@ -318,5 +318,5 @@
     start_module
     start_vboxflt
-    start_vboxusb
+    start_vboxusbmon
 }
 
@@ -359,8 +359,8 @@
     ;;
 usbstart)
-    start_vboxusb
+    start_vboxusbmon
     ;;
 usbstop)
-    stop_vboxusb
+    stop_vboxusbmon
     ;;
 *)