Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxFilePathSelectorWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxFilePathSelectorWidget.h	(revision 17713)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxFilePathSelectorWidget.h	(revision 17714)
@@ -63,4 +63,7 @@
     QString fileFilters() const;
 
+    void setDefaultSaveExt (const QString &aExt);
+    QString defaultSaveExt() const;
+
     void resetModified();
     bool isModified() const;
@@ -107,4 +110,5 @@
     QString mHomeDir;
     QString mFileFilters;
+    QString mDefaultSaveExt;
     QString mFileDialogTitle;
     QString mNoneStr;
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 17713)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 17714)
@@ -36,4 +36,6 @@
 #include <QProcess>
 #include <QHash>
+#include <QDesktopServices>
+#include <QDir>
 
 class QAction;
@@ -731,4 +733,15 @@
     }
 
+    static inline QString documentsPath()
+    {
+        QString path;
+#if QT_VERSION < 0x040400
+        path = QDir::homePath();
+#else
+        path = QDesktopServices::storageLocation (QDesktopServices::DocumentsLocation);
+#endif
+        return QDir::cleanPath (path);
+    }
+
 signals:
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxExportApplianceWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxExportApplianceWzd.cpp	(revision 17713)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxExportApplianceWzd.cpp	(revision 17714)
@@ -26,7 +26,4 @@
 #include "VBoxProblemReporter.h"
 
-/* Qt includes */
-#include <QDir>
-
 class VMListWidgetItems: public QListWidgetItem
 {
@@ -76,4 +73,5 @@
     mFileSelector->setFileDialogTitle (tr ("Select a file to export into"));
     mFileSelector->setFileFilters (tr ("Open Virtualization Format (%1)").arg ("*.ovf"));
+    mFileSelector->setDefaultSaveExt ("ovf");
 #ifdef Q_WS_MAC
     /* Editable boxes are uncommon on the Mac */
@@ -151,5 +149,5 @@
                 name = mVMListWidget->selectedItems().first()->text();
 
-            mFileSelector->setPath (QDir::toNativeSeparators (QString ("%1/%2.ovf").arg (QDir::currentPath())
+            mFileSelector->setPath (QDir::toNativeSeparators (QString ("%1/%2.ovf").arg (vboxGlobal().documentsPath())
                                                                                    .arg (name)));
             mWValFileSelector->revalidate();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFilePathSelectorWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFilePathSelectorWidget.cpp	(revision 17713)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFilePathSelectorWidget.cpp	(revision 17714)
@@ -190,4 +190,14 @@
 }
 
+void VBoxFilePathSelectorWidget::setDefaultSaveExt (const QString &aExt)
+{
+    mDefaultSaveExt = aExt;
+}
+
+QString VBoxFilePathSelectorWidget::defaultSaveExt() const
+{
+    return mDefaultSaveExt;
+}
+
 /**
  * Returns @c true if the selected (active) combobox item is a path item.
@@ -377,5 +387,10 @@
             path = VBoxGlobal::getOpenFileName (initDir, mFileFilters, parentWidget(), mFileDialogTitle); break;
         case Mode_File_Save:
-            path = VBoxGlobal::getSaveFileName (initDir, mFileFilters, parentWidget(), mFileDialogTitle); break;
+            {
+                path = VBoxGlobal::getSaveFileName (initDir, mFileFilters, parentWidget(), mFileDialogTitle); 
+                if (QFileInfo (path).suffix().isEmpty())
+                    path = QString ("%1.%2").arg (path).arg (mDefaultSaveExt);
+                break;
+            }
         case Mode_Folder:
             path = VBoxGlobal::getExistingDirectory (initDir, parentWidget(), mFileDialogTitle); break;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp	(revision 17713)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp	(revision 17714)
@@ -45,4 +45,5 @@
     mFileSelector->setFileDialogTitle (tr ("Select an appliance to import"));
     mFileSelector->setFileFilters (tr ("Open Virtualization Format (%1)").arg ("*.ovf"));
+    mFileSelector->setHomeDir (vboxGlobal().documentsPath());
 #ifdef Q_WS_MAC
     /* Editable boxes are uncommon on the Mac */