Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 17729)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 17730)
@@ -327,4 +327,5 @@
 	src/VBoxMediaComboBox.cpp \
 	src/VBoxProblemReporter.cpp \
+	src/VBoxHelpActions.cpp \
 	src/VBoxSelectorWnd.cpp \
 	src/VBoxConsoleView.cpp \
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h	(revision 17729)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h	(revision 17730)
@@ -29,4 +29,5 @@
 
 #include "VBoxProblemReporter.h"
+#include "VBoxHelpActions.h"
 
 /* Qt includes */
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxHelpActions.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxHelpActions.h	(revision 17730)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxHelpActions.h	(revision 17730)
@@ -0,0 +1,65 @@
+/** @file
+ *
+ * VBox frontends: Qt GUI ("VirtualBox"):
+ * VBoxHelpActions class declaration
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+#ifndef __VBoxHelpActions_h__
+#define __VBoxHelpActions_h__
+
+/* Qt includes */
+#include <QObject>
+
+class QMenu;
+class QAction;
+
+/**
+ * Help Menu action container.
+ *
+ * Contains actions for all help menu items and methods to insert them to a
+ * QMenu and to perform NLS string translation.
+ *
+ * Instances of this class are to be created as members of QWidget classes that
+ * need a Help menu. The containing class usually passes itself as an argument
+ * to the #setup() method and then calls #addTo() to add actions to its Help
+ * menu. The #retranslateUi() method is called when it is necessary to
+ * re-translate all action NLS according to the current language.
+ */
+struct VBoxHelpActions
+{
+    VBoxHelpActions()
+        : contentsAction (NULL), webAction (NULL)
+        , resetMessagesAction (NULL), registerAction (NULL)
+        , updateAction (NULL), aboutAction (NULL)
+        {}
+
+    void setup (QObject *aParent);
+    void addTo (QMenu *aMenu);
+    void retranslateUi();
+
+    QAction *contentsAction;
+    QAction *webAction;
+    QAction *resetMessagesAction;
+    QAction *registerAction;
+    QAction *updateAction;
+    QAction *aboutAction;
+};
+
+#endif /* __VBoxHelpActions_h__ */
+
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxProblemReporter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxProblemReporter.h	(revision 17729)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxProblemReporter.h	(revision 17730)
@@ -31,41 +31,4 @@
 
 class VBoxMedium;
-class QAction;
-class QMenu;
-
-// VBoxHelpActions class
-////////////////////////////////////////////////////////////////////////////////
-
-/**
- * Help Menu action container.
- *
- * Contains actions for all help menu items and methods to insert them to a
- * QMenu and to perform NLS string translation.
- *
- * Instances of this class are to be created as members of QWidget classes that
- * need a Help menu. The containing class usually passes itself as an argument
- * to the #setup() method and then calls #addTo() to add actions to its Help
- * menu. The #retranslateUi() method is called when it is necessary to
- * re-translate all action NLS according to the current language.
- */
-struct VBoxHelpActions
-{
-    VBoxHelpActions()
-        : contentsAction (NULL), webAction (NULL)
-        , resetMessagesAction (NULL), registerAction (NULL)
-        , updateAction (NULL), aboutAction (NULL)
-        {}
-
-    void setup (QObject *aParent);
-    void addTo (QMenu *aMenu);
-    void retranslateUi();
-
-    QAction *contentsAction;
-    QAction *webAction;
-    QAction *resetMessagesAction;
-    QAction *registerAction;
-    QAction *updateAction;
-    QAction *aboutAction;
-};
 
 // VBoxProblemReporter class
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h	(revision 17729)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSelectorWnd.h	(revision 17730)
@@ -30,4 +30,5 @@
 #include "VBoxGlobal.h"
 #include "VBoxProblemReporter.h"
+#include "VBoxHelpActions.h"
 
 /* Qt includes */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxHelpActions.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxHelpActions.cpp	(revision 17730)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxHelpActions.cpp	(revision 17730)
@@ -0,0 +1,128 @@
+/** @file
+ *
+ * VBox frontends: Qt GUI ("VirtualBox"):
+ * VBoxHelpActions class implementation
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+#include "VBoxHelpActions.h"
+#include "VBoxGlobal.h"
+#include "VBoxProblemReporter.h"
+
+/* Qt includes */
+#include <QMenu>
+
+void VBoxHelpActions::setup (QObject *aParent)
+{
+    AssertReturnVoid (contentsAction == NULL);
+
+    contentsAction = new QAction (aParent);
+    contentsAction->setIcon (VBoxGlobal::iconSet (":/help_16px.png"));
+
+    webAction = new QAction (aParent);
+    webAction->setIcon (VBoxGlobal::iconSet (":/site_16px.png"));
+
+    resetMessagesAction = new QAction (aParent);
+    resetMessagesAction->setIcon (VBoxGlobal::iconSet (":/reset_16px.png"));
+
+    registerAction = new QAction (aParent);
+    registerAction->setIcon (VBoxGlobal::iconSet (":/register_16px.png",
+                                                  ":/register_disabled_16px.png"));
+    updateAction = new QAction (aParent);
+    updateAction->setIcon (VBoxGlobal::iconSet (":/refresh_16px.png",
+                                                ":/refresh_disabled_16px.png"));
+    aboutAction = new QAction (aParent);
+    aboutAction->setMenuRole (QAction::AboutRole);
+    aboutAction->setIcon (VBoxGlobal::iconSet (":/about_16px.png"));
+
+    QObject::connect (contentsAction, SIGNAL (triggered()),
+                      &vboxProblem(), SLOT (showHelpHelpDialog()));
+    QObject::connect (webAction, SIGNAL (triggered()),
+                      &vboxProblem(), SLOT (showHelpWebDialog()));
+    QObject::connect (resetMessagesAction, SIGNAL (triggered()),
+                      &vboxProblem(), SLOT (resetSuppressedMessages()));
+    QObject::connect (registerAction, SIGNAL (triggered()),
+                      &vboxGlobal(), SLOT (showRegistrationDialog()));
+    QObject::connect (updateAction, SIGNAL (triggered()),
+                      &vboxGlobal(), SLOT (showUpdateDialog()));
+    QObject::connect (aboutAction, SIGNAL (triggered()),
+                      &vboxProblem(), SLOT (showHelpAboutDialog()));
+
+    QObject::connect (&vboxGlobal(), SIGNAL (canShowRegDlg (bool)),
+                      registerAction, SLOT (setEnabled (bool)));
+    QObject::connect (&vboxGlobal(), SIGNAL (canShowUpdDlg (bool)),
+                      updateAction, SLOT (setEnabled (bool)));
+}
+
+void VBoxHelpActions::addTo (QMenu *aMenu)
+{
+    AssertReturnVoid (contentsAction != NULL);
+
+    aMenu->addAction (contentsAction);
+    aMenu->addAction (webAction);
+    aMenu->addSeparator();
+
+    aMenu->addAction (resetMessagesAction);
+    aMenu->addSeparator();
+
+#ifdef VBOX_WITH_REGISTRATION
+    aMenu->addAction (registerAction);
+    registerAction->setEnabled (vboxGlobal().virtualBox().
+        GetExtraData (VBoxDefs::GUI_RegistrationDlgWinID).isEmpty());
+#endif
+
+    aMenu->addAction (updateAction);
+    updateAction->setEnabled (vboxGlobal().virtualBox().
+        GetExtraData (VBoxDefs::GUI_UpdateDlgWinID).isEmpty());
+
+#ifndef Q_WS_MAC
+    aMenu->addSeparator();
+#endif /* Q_WS_MAC */
+    aMenu->addAction (aboutAction);
+}
+
+void VBoxHelpActions::retranslateUi()
+{
+    AssertReturnVoid (contentsAction != NULL);
+
+    contentsAction->setText (VBoxProblemReporter::tr ("&Contents..."));
+    contentsAction->setShortcut (QKeySequence::HelpContents);
+    contentsAction->setStatusTip (VBoxProblemReporter::tr (
+        "Show the online help contents"));
+
+    webAction->setText (VBoxProblemReporter::tr ("&VirtualBox Web Site..."));
+    webAction->setStatusTip (VBoxProblemReporter::tr (
+        "Open the browser and go to the VirtualBox product web site"));
+
+    resetMessagesAction->setText (VBoxProblemReporter::tr ("&Reset All Warnings"));
+    resetMessagesAction->setStatusTip (VBoxProblemReporter::tr (
+        "Cause all suppressed warnings and messages to be shown again"));
+
+    registerAction->setText (VBoxProblemReporter::tr ("R&egister VirtualBox..."));
+    registerAction->setStatusTip (VBoxProblemReporter::tr (
+        "Open VirtualBox registration form"));
+
+    updateAction->setText (VBoxProblemReporter::tr ("C&heck for Updates..."));
+    updateAction->setStatusTip (VBoxProblemReporter::tr (
+        "Check for a new VirtualBox version"));
+
+    aboutAction->setText (VBoxProblemReporter::tr ("&About VirtualBox..."));
+    aboutAction->setStatusTip (VBoxProblemReporter::tr (
+        "Show a dialog with product information"));
+}
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp	(revision 17729)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxProblemReporter.cpp	(revision 17730)
@@ -197,107 +197,4 @@
 
 const char *VBoxProgressDialog::sOpDescTpl = "%1... (%2/%3)";
-
-////////////////////////////////////////////////////////////////////////////////
-// VBoxHelpActions class
-////////////////////////////////////////////////////////////////////////////////
-
-void VBoxHelpActions::setup (QObject *aParent)
-{
-    AssertReturnVoid (contentsAction == NULL);
-
-    contentsAction = new QAction (aParent);
-    contentsAction->setIcon (VBoxGlobal::iconSet (":/help_16px.png"));
-
-    webAction = new QAction (aParent);
-    webAction->setIcon (VBoxGlobal::iconSet (":/site_16px.png"));
-
-    resetMessagesAction = new QAction (aParent);
-    resetMessagesAction->setIcon (VBoxGlobal::iconSet (":/reset_16px.png"));
-
-    registerAction = new QAction (aParent);
-    registerAction->setIcon (VBoxGlobal::iconSet (":/register_16px.png",
-                                                  ":/register_disabled_16px.png"));
-    updateAction = new QAction (aParent);
-    updateAction->setIcon (VBoxGlobal::iconSet (":/refresh_16px.png",
-                                                ":/refresh_disabled_16px.png"));
-    aboutAction = new QAction (aParent);
-    aboutAction->setMenuRole (QAction::AboutRole);
-    aboutAction->setIcon (VBoxGlobal::iconSet (":/about_16px.png"));
-
-    QObject::connect (contentsAction, SIGNAL (triggered()),
-                      &vboxProblem(), SLOT (showHelpHelpDialog()));
-    QObject::connect (webAction, SIGNAL (triggered()),
-                      &vboxProblem(), SLOT (showHelpWebDialog()));
-    QObject::connect (resetMessagesAction, SIGNAL (triggered()),
-                      &vboxProblem(), SLOT (resetSuppressedMessages()));
-    QObject::connect (registerAction, SIGNAL (triggered()),
-                      &vboxGlobal(), SLOT (showRegistrationDialog()));
-    QObject::connect (updateAction, SIGNAL (triggered()),
-                      &vboxGlobal(), SLOT (showUpdateDialog()));
-    QObject::connect (aboutAction, SIGNAL (triggered()),
-                      &vboxProblem(), SLOT (showHelpAboutDialog()));
-
-    QObject::connect (&vboxGlobal(), SIGNAL (canShowRegDlg (bool)),
-                      registerAction, SLOT (setEnabled (bool)));
-    QObject::connect (&vboxGlobal(), SIGNAL (canShowUpdDlg (bool)),
-                      updateAction, SLOT (setEnabled (bool)));
-}
-
-void VBoxHelpActions::addTo (QMenu *aMenu)
-{
-    AssertReturnVoid (contentsAction != NULL);
-
-    aMenu->addAction (contentsAction);
-    aMenu->addAction (webAction);
-    aMenu->addSeparator();
-
-    aMenu->addAction (resetMessagesAction);
-    aMenu->addSeparator();
-
-#ifdef VBOX_WITH_REGISTRATION
-    aMenu->addAction (registerAction);
-    registerAction->setEnabled (vboxGlobal().virtualBox().
-        GetExtraData (VBoxDefs::GUI_RegistrationDlgWinID).isEmpty());
-#endif
-
-    aMenu->addAction (updateAction);
-    updateAction->setEnabled (vboxGlobal().virtualBox().
-        GetExtraData (VBoxDefs::GUI_UpdateDlgWinID).isEmpty());
-
-#ifndef Q_WS_MAC
-    aMenu->addSeparator();
-#endif /* Q_WS_MAC */
-    aMenu->addAction (aboutAction);
-}
-
-void VBoxHelpActions::retranslateUi()
-{
-    AssertReturnVoid (contentsAction != NULL);
-
-    contentsAction->setText (VBoxProblemReporter::tr ("&Contents..."));
-    contentsAction->setShortcut (QKeySequence::HelpContents);
-    contentsAction->setStatusTip (VBoxProblemReporter::tr (
-        "Show the online help contents"));
-
-    webAction->setText (VBoxProblemReporter::tr ("&VirtualBox Web Site..."));
-    webAction->setStatusTip (VBoxProblemReporter::tr (
-        "Open the browser and go to the VirtualBox product web site"));
-
-    resetMessagesAction->setText (VBoxProblemReporter::tr ("&Reset All Warnings"));
-    resetMessagesAction->setStatusTip (VBoxProblemReporter::tr (
-        "Cause all suppressed warnings and messages to be shown again"));
-
-    registerAction->setText (VBoxProblemReporter::tr ("R&egister VirtualBox..."));
-    registerAction->setStatusTip (VBoxProblemReporter::tr (
-        "Open VirtualBox registration form"));
-
-    updateAction->setText (VBoxProblemReporter::tr ("C&heck for Updates..."));
-    updateAction->setStatusTip (VBoxProblemReporter::tr (
-        "Check for a new VirtualBox version"));
-
-    aboutAction->setText (VBoxProblemReporter::tr ("&About VirtualBox..."));
-    aboutAction->setStatusTip (VBoxProblemReporter::tr (
-        "Show a dialog with product information"));
-}
 
 ////////////////////////////////////////////////////////////////////////////////